<?php

$request_uri_without_querystring = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
if (strpos($request_uri_without_querystring, "?") !== false) {
	$request_uri_without_querystring = reset(explode('?', $request_uri_without_querystring));
}
	
if (array_key_exists('redirect', $_POST)
|| array_key_exists('redirect', $_GET)) {
	header('Location: '.$request_uri_without_querystring, true, 303);
	exit();
}
if (array_key_exists('refresh', $_POST)
|| array_key_exists('refresh', $_GET)) {
	header('Refresh: 0;url='.$request_uri_without_querystring);
	echo 'You\'ll be redirected in about 1 secs. If not, click <a href="'.$request_uri_without_querystring.'">here</a>.';
	exit();
}
//HTTP 1.1
header('Cache-Control: no-cache, no-store, must-revalidate, max-age=0');
//HTTP 1.0
header('Pragma: no-cache');
//date in the past
header('Expires: ' . gmdate(DATE_RFC1123, time()-1));

?>
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<title>Chrome and Safari discard cache on Post/Redirect/Get</title>
<style>
.ok {
	background:#99FF99;
	color:#006600;
}
.nok {
	background:#FF9999;
	color:#660000;
}
</style>
</head>
<body>
<p><img src="image.php" width="100" height="100" alt=""></p>
<form action="." method="post">
  <table>
    <tr>
      <th>click to test</th>
      <th>IE 6</th>
      <th>IE 7</th>
      <th>IE 8</th>
      <th>IE 9 pp3</th>
      <th>ff 3.6.4</th>
      <th>op 10</th>
      <th>chrome 6 to 8</th>
      <th>saf 5</th>
      <th>saf mobile 3.1.3</th>
      <th>saf iOS 4</th>
      <th>saf iOS 4.0.1</th>
      <th>saf iOS 4.2.1</th>
    </tr>
    <tr>
      <td><a href=".">Get</a></td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
    </tr>
    <tr>
      <td><a href=".?redirect=true">Get/Redirect/Get</a></td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
    </tr>
    <tr>
      <td><input type="submit" value="Post"></td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
    </tr>
    <tr>
      <td><input type="submit" name="redirect" value="Post/Redirect/Get"></td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="ok">OK</td>
      <td class="nok">NOK</td>
      <td class="nok">NOK</td>
      <td class="ok">OK</td>
      <td class="nok">NOK</td>
      <td class="nok">NOK</td>
      <td class="nok">NOK</td>
    </tr>
    <tr>
      <td><input type="submit" name="refresh" value="Post/Refresh/Get"></td>
      <td class="">?</td>
      <td class="">?</td>
      <td class="nok">NOK **</td>
      <td class="nok">NOK **</td>
      <td class="ok">OK *</td>
      <td class="">OK *</td>
      <td class="ok">OK *</td>
      <td class="ok">OK</td>
      <td class="">?</td>
      <td class="">?</td>
      <td class="">?</td>
      <td class="ok">OK *</td>
    </tr>
  </table>
</form>

<p>(*) Refresh is noticably slower than Redirect and causes a white flash in Firefox, Opera, Chrome and Safari mobile.<br>
(**) Interenet Explorer reloads the image after a Post/Refresh/Get.<p>


<p>The image above should not reload from the server. However in Safari 5, Chrome 6 and Safari mobile on iOS 4 (and iOS 4.0.1) the image reloads from the server after a <a href="http://en.wikipedia.org/wiki/Post/Redirect/Get">Post/Redirect/Get</a>. This problem didn't occur on Safari mobile on iPhone OS 3.1.3. This appears to be a regression.</p>

<p>The Response headers sent with the image:</p>

<pre>HTTP/1.1 200 OK
Date: Thu, 24 Jun 2010 12:02:33 GMT
Server: Apache
Cache-Control: public, max-age=32140800
Expires: Fri, 01 Jul 2011 12:02:35 GMT
Etag: &quot;866-1276639825&quot;
Last-Modified: Tue, 15 Jun 2010 22:10:25 GMT
Content-Length: 866
Content-Type: image/png</pre>

<hr>
<p><a href="prg.zip">Download sourcecode</a></p>

</body>
</html>
